-- Gives +15% production for every National Wonder
INSERT INTO Policy_BuildingClassProductionModifiers(PolicyType, BuildingClassType, ProductionModifier)
	SELECT 'POLICY_OLIGARCHY', Type, 15
	FROM BuildingClasses
	WHERE MaxPlayerInstances = 1 AND DefaultBuilding IN	(SELECT BuildingType FROM Building_PrereqBuildingClasses WHERE NumBuildingNeeded = -1);

-----------------------
-- DATABASE TRIGGERS --
-----------------------
-- Adds entries for a inserted national wonder
CREATE TRIGGER IF NOT EXISTS Oligarchy_BuildingClasses_NewNationalWonderInsert
AFTER INSERT ON BuildingClasses
WHEN ((NEW.MaxPlayerInstances = 1) AND (NEW.DefaultBuilding IN (SELECT BuildingType FROM Building_PrereqBuildingClasses WHERE NumBuildingNeeded = -1)))
BEGIN
	INSERT INTO Policy_BuildingClassProductionModifiers(PolicyType, BuildingClassType, ProductionModifier)
	VALUES('POLICY_OLIGARCHY', NEW.Type, 15);
END;

CREATE TRIGGER IF NOT EXISTS Oligarchy_Building_PrereqBuildingClasses_NewNationalWonderInsert
AFTER INSERT ON Building_PrereqBuildingClasses
WHEN ((NEW.NumBuildingNeeded = -1) AND (NEW.BuildingType IN (SELECT DefaultBuilding FROM BuildingClasses WHERE MaxPlayerInstances = 1)))
BEGIN
	INSERT INTO Policy_BuildingClassProductionModifiers(PolicyType, BuildingClassType, ProductionModifier)
		SELECT 'POLICY_OLIGARCHY', Type, 15
		FROM BuildingClasses
		WHERE NEW.BuildingType = DefaultBuilding;
END;

--TODO: Add triggers for edits that turn National Wonders into something else.