-- Adds +1 Production for every non-luxury Resource
INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	SELECT 'BUILDING_LIBERTY_FINISHER', Type, 'YIELD_PRODUCTION', 1
	FROM Resources
	WHERE Happiness = 0;

-----------------------
-- DATABASE TRIGGERS --
-----------------------
-- Adds entries for a inserted resource
CREATE TRIGGER LibertyFinisher_NewResourceInsert
AFTER INSERT ON Resources
WHEN NEW.Happiness = 0
BEGIN
	INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	VALUES('BUILDING_LIBERTY_FINISHER', NEW.Type, 'YIELD_PRODUCTION', 1);
END;

--INSERT INTO Resources(Type, Happiness)
--VALUES('RESOURCE_LIB_TEST', 0);

-- Adds entries for resources that stop being luxuries
CREATE TRIGGER LibertyFinisher_LuxuryResourceUpdated
AFTER UPDATE OF Happiness ON Resources
WHEN (OLD.Happiness > 0 AND NEW.Happiness = 0)
BEGIN
	INSERT INTO Building_ResourceYieldChanges(BuildingType, ResourceType, YieldType, Yield)
	VALUES('BUILDING_LIBERTY_FINISHER', NEW.Type, 'YIELD_PRODUCTION', 1);
END;

-- Removes entries for resources that become luxury
CREATE TRIGGER LibertyFinisher_LuxuryResourceDeleted
AFTER UPDATE OF Happiness ON Resources
WHEN (OLD.Happiness = 0 AND NEW.Happiness > 0)
BEGIN
	DELETE FROM Building_ResourceYieldChanges
	WHERE ResourceType = NEW.Type
	AND BuildingType = 'BUILDING_LIBERTY_FINISHER';
END;