-- Leadership
-- Author: Machiavelli
-- DateCreated: 2/19/2014 8:35:46 PM
--------------------------------------------------------------
function ScienceFromGreatGeneral(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local player = Players[playerID];
	local unit = player:GetUnitByID(unitID);
	local policyID = GameInfoTypes["POLICY_WARRIOR_CODE"];

	-- Only continue if player has the policy and the unit is a great prophet
	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID) and unit:GetUnitClassType() == GameInfoTypes["UNITCLASS_GREAT_GENERAL"]) then
		-- Handle the Science
		local team = Teams[player:GetTeam()];
		local teamTechs = team:GetTeamTechs();
		local currentTech = GetCurrentOrLegalTech(playerID);

		-- Do not continue if no legal tech could be found
		if (currentTech == -1) then
			return
		end

		local bonus = 250;
		-- Adjust the size of the bonus based on the game speed
		local adjustedBonus = (bonus * GameInfo.GameSpeeds[Game:GetGameSpeedType()].ResearchPercent) / 100;

		-- Give the bonus science
		teamTechs:ChangeResearchProgress(currentTech, adjustedBonus, playerID);
		
		-- Send a notification to the player
		local header = Locale.ConvertTextKey("TXT_KEY_SCIENCE_FROM_GENERAL_HEADER", tostring(adjustedBonus), unit:GetName());
		local text = Locale.ConvertTextKey("TXT_KEY_SCIENCE_FROM_GENERAL_BODY", tostring(adjustedBonus), unit:GetName());

		player:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, text, header);
	end
end
LuaEvents.SerialEventUnitCreatedGood.Add(ScienceFromGreatGeneral);

------------------------------
-- Private helper functions --
------------------------------
function GetCurrentOrLegalTech(playerID)
	local player = Players[playerID];
	
	if(player:GetCurrentResearch() ~= nil and player:GetCurrentResearch() >= 0) then
		return player:GetCurrentResearch();
	end
	-- Find a valid tech and return that
	for row in GameInfo.Technologies() do
		if(player:CanResearch(row.ID)) then
			return row.ID;
		end
	end
	-- Could not find a valid tech
	return -1;
end