-- Mandate of Heaven
-- Author: Machiavelli
-- DateCreated: 2/19/2014 8:35:46 PM
--------------------------------------------------------------
function GoldenAgeGreatProphetWriter(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local player = Players[playerID];
	local unit = player:GetUnitByID(unitID);
	local policyID = GameInfoTypes["POLICY_MANDATE_OF_HEAVEN"];

	-- Only continue if player has the policy and the unit is a great prophet
	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID) and (unit:GetUnitClassType() == GameInfoTypes["UNITCLASS_PROPHET"] or unit:GetUnitClassType() == GameInfoTypes["UNITCLASS_WRITER"])) then
		local bonus = 6;

		local playerDurationMod = player:GetGoldenAgeModifier(); -- From policies and buildings
		local trait = GameInfo.Leader_Traits[player:GetLeaderType()].TraitType;
		local traitDurationMod = GameInfo.Traits[trait].GoldenAgeDurationModifier; -- ei: persia
		local speedDurationMod = GameInfo.GameSpeeds[Game:GetGameSpeedType()].GoldenAgePercent;

		-- Adjust the size of the bonus
		local adjustedBonus = (bonus * (speedDurationMod + playerDurationMod + traitDurationMod)) / 100;

		player:ChangeGoldenAgeTurns(adjustedBonus);

		-- Send a notification to the player
		local header = Locale.ConvertTextKey("TXT_KEY_GOLDEN_AGE_PROPHIT_HEADER");
		local text = Locale.ConvertTextKey("TXT_KEY_GOLDEN_AGE_PROPHIT_BODY", tostring(adjustedBonus), unit:GetName());

		player:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, text, header);
	end
end
LuaEvents.SerialEventUnitCreatedGood.Add(GoldenAgeGreatProphetWriter);