-- Ordained Priesthood
-- Author: Machiavelli
-- DateCreated: 2/19/2014 10:03:40 PM
--------------------------------------------------------------
function OrdainedPriesthood(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local player = Players[playerID];
	local unit = player:GetUnitByID(unitID);
	local policyID = GameInfoTypes["POLICY_FREE_RELIGION"];
	local plot = unit:GetPlot();

	-- Only if the player has the policy and this is missionary/inquisitor
	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID) and plot:IsCity() and (unit:GetUnitClassType() == GameInfoTypes["UNITCLASS_MISSIONARY"] or unit:GetUnitClassType() == GameInfoTypes["UNITCLASS_INQUISITOR"])) then
		local city = plot:GetPlotCity();

		city:ChangePopulation(1, true);

		-- Send a notification to the player
		local header = Locale.ConvertTextKey("TXT_KEY_NEW_ORDAINED_PRIESTHOOD_HEADER");
		local text = Locale.ConvertTextKey("TXT_KEY_NEW_ORDAINED_PRIESTHOOD_BODY", city:GetName());
		player:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, text, header);
	end
end
LuaEvents.SerialEventUnitCreatedGood.Add(OrdainedPriesthood);