-- Adds +1 Happiness for each World Wonder
INSERT INTO Policy_BuildingClassHappiness(PolicyType, BuildingClassType, Happiness)
	SELECT 'POLICY_FINE_ARTS', Type, 1
	FROM BuildingClasses
	WHERE MaxGlobalInstances = 1;

-----------------------
-- DATABASE TRIGGERS --
-----------------------
-- Adds entries for new world wonders
CREATE TRIGGER FineArts_NewWonderInsert
AFTER INSERT ON BuildingClasses
WHEN NEW.MaxGlobalInstances = 1
BEGIN
	INSERT INTO Policy_BuildingClassHappiness(PolicyType, BuildingClassType, Happiness)
	VALUES('POLICY_FINE_ARTS', NEW.Type, 1);
END;
--INSERT INTO BuildingClasses(Type, MaxGlobalInstances)
--VALUES('BUILDINGCLASS_FINE_ARTS_TEST', 1);

-- Adds entries for buildings that are now wonders
CREATE TRIGGER FineArts_NewWonderUpdated
AFTER UPDATE ON BuildingClasses
WHEN (OLD.MaxGlobalInstances = 0 and NEW.MaxGlobalInstances = 1)
BEGIN
	INSERT INTO Policy_BuildingClassHappiness(PolicyType, BuildingClassType, Happiness)
	VALUES('POLICY_FINE_ARTS', NEW.Type, 1);
END;

-- Removes entries for wonders that are now normal buildings
CREATE TRIGGER FineArts_NewWonderDeleted
AFTER UPDATE ON BuildingClasses
WHEN (OLD.MaxGlobalInstances = 1 and NEW.MaxGlobalInstances = 0)
BEGIN
	DELETE FROM Policy_BuildingClassHappiness
	WHERE BuildingClassType = NEW.Type
	AND PolicyType = 'POLICY_FINE_ARTS';
END;