-- Liberalism
-- Author: Machiavelli
-- DateCreated: 5/6/2013 11:13:24 PM
--------------------------------------------------------------
function GiveHappinessPerSocialPolicy(playerID)
	local player = Players[playerID];
	local city = player:GetCapitalCity();
	local policyID = GameInfoTypes["POLICY_UNIVERSAL_HEALTHCARE_F"];

	-- If the player has the policy "liberalism" (POLICY_UNIVERSAL_HEALTHCARE_F)
	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID)) then
		-- 1 happiness for every two social policies
		local happinessBonus = math.floor(player:GetNumPolicies() / 2);

		city:SetNumRealBuilding(GameInfoTypes["BUILDING_HAPPINESS_PER_SOCIAL_POLICY"], happinessBonus);
	else
		city:SetNumRealBuilding(GameInfoTypes["BUILDING_HAPPINESS_PER_SOCIAL_POLICY"], 0);
	end
end
GameEvents.PlayerAdoptPolicy.Add(GiveHappinessPerSocialPolicy);
GameEvents.PlayerAdoptPolicyBranch.Add(GiveHappinessPerSocialPolicy);

function HappinessPerSocialPolicyCapitalMove(oldPlayerID, bCapital, iX, iY, newPlayerID, conquest, conquest2)
	local oldPlayer = Players[oldPlayerID];
	local newPlayer = Players[newPlayerID];
	local city =  Map.GetPlot(iX, iY):GetPlotCity();
	local policyID = GameInfoTypes["POLICY_DEMOCRACY"];

	-- If the old player just lost their capital, they may need to have their buildings replaced
	if(bCapital and oldPlayer:IsAlive() and not oldPlayer:IsMinorCiv() and not oldPlayer:IsBarbarian() and oldPlayer:HasPolicy(policyID) and not oldPlayer:IsPolicyBlocked(policyID)) then
		GiveHappinessPerSocialPolicy(oldPlayerID);
	end

	-- If the new player just recovered their capital, they will need to have their buildings moved
	if(newPlayer:GetCapitalCity():GetID() == city:GetID()) then
		-- Remove capital only buildings from the new player's cities
		for cityToRemove in newPlayer:Cities() do
			cityToRemove:SetNumRealBuilding(GameInfoTypes["BUILDING_HAPPINESS_PER_SOCIAL_POLICY"], 0);
		end
		-- Add back the capital-only policy buildings
		GiveHappinessPerSocialPolicy(newPlayerID);
	end
end
GameEvents.CityCaptureComplete.Add(HappinessPerSocialPolicyCapitalMove);

function DisableBlockedLiberalism(playerID)
	local player = Players[playerID];
	local policyID = GameInfoTypes["POLICY_UNIVERSAL_HEALTHCARE_F"];

	if(player:HasPolicy(policyID) and player:IsPolicyBlocked(policyID)) then
		local city = player:GetCapitalCity();
		city:SetNumRealBuilding(GameInfoTypes["BUILDING_HAPPINESS_PER_SOCIAL_POLICY"], 0);
	end
end
GameEvents.PlayerDoTurn.Add(DisableBlockedLiberalism);