-- Urbanization
-- Author: Machiavelli
-- DateCreated: 5/11/2013 12:24:53 PM
--------------------------------------------------------------
function AddBithplaceTourismToAllCities(playerID, policyTypeID)
	local player = Players[playerID];
	local policyID = GameInfoTypes["POLICY_URBANIZATION"];

	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID)) then
		for city in player:Cities() do
			local birthplaceCount = 0;
			if(city:IsHasBuilding(GameInfoTypes["BUILDING_GREAT_ENGINEER"])) then
				birthplaceCount = birthplaceCount + 1;
			end
			if(city:IsHasBuilding(GameInfoTypes["BUILDING_GREAT_MERCHANT"])) then
				birthplaceCount = birthplaceCount + 1;
			end
			if(city:IsHasBuilding(GameInfoTypes["BUILDING_GREAT_SCIENTIST"])) then
				birthplaceCount = birthplaceCount + 1;
			end
			city:SetNumRealBuilding(GameInfoTypes["BUILDING_TOURISM_FROM_BIRTHPLACE"], birthplaceCount);
		end
	end
end
GameEvents.PlayerAdoptPolicy.Add(AddBithplaceTourismToAllCities);
GameEvents.PlayerAdoptPolicyBranch.Add(AddBithplaceTourismToAllCities);

function DisableBlockedBirthplaceTourism(playerID)
	local player = Players[playerID];
	local policyID = GameInfoTypes["POLICY_URBANIZATION"];

	if(player:HasPolicy(policyID) and player:IsPolicyBlocked(policyID)) then
		for city in player:Cities() do
			city:SetNumRealBuilding(GameInfoTypes["BUILDING_TOURISM_FROM_BIRTHPLACE"], 0);
		end
	end
end
GameEvents.PlayerDoTurn.Add(DisableBlockedBirthplaceTourism);