-- Educated Officers
-- Author: Machiavelli
-- DateCreated: 5/31/2012 1:51:00 PM
--------------------------------------------------------------
function GiveScienceWhenCreated(playerID, unitID, hexVec, unitType, cultureType, civID, primaryColor, secondaryColor, unitFlagIndex, fogState, selected, military, notInvisible)
	local player = Players[playerID];
	local unit = player:GetUnitByID(unitID);
	local policyID = GameInfoTypes["POLICY_TOTAL_WAR"];

	-- Only give the Culture if the player has the policy
	if(player:HasPolicy(policyID) and not player:IsPolicyBlocked(policyID) and unit:GetUnitCombatType() == GameInfoTypes["UNITCOMBAT_GUN"]) then
		-- Handle the Science --------------
		local team = Teams[player:GetTeam()];
		local teamTechs = team:GetTeamTechs();
		local currentTech = GetCurrentOrLegalTech(playerID);

		-- Do not continue if no legal tech could be found
		if (currentTech == -1) then
			return
		end

		-- Give the bonus science
		local bonus = unit:GetBaseCombatStrength();
		teamTechs:ChangeResearchProgress(currentTech, bonus, playerID);

		-- Send a notification to the player
		local text = Locale.ConvertTextKey("TXT_KEY_SCIENCE_FROM_EDUCATED_OFFICERS", tostring(bonus), unit:GetName());
		player:AddNotification(NotificationTypes.NOTIFICATION_GENERIC, text, text);
	end
end
LuaEvents.SerialEventUnitCreatedGood.Add(GiveScienceWhenCreated);

------------------------------
-- Private helper functions --
------------------------------
function GetCurrentOrLegalTech(playerID)
	local player = Players[playerID];
	
	if(player:GetCurrentResearch() ~= nil and player:GetCurrentResearch() >= 0) then
		return player:GetCurrentResearch();
	end
	-- Find a valid tech and return that
	for row in GameInfo.Technologies() do
		if(player:CanResearch(row.ID)) then
			return row.ID;
		end
	end
	-- Could not find a valid tech
	return -1;
end